avcodec/mips: cabac.h provide fallback for wsbh instruction
[ffmpeg.git] / tests / fate-run.sh
1 #! /bin/sh
2
3 export LC_ALL=C
4
5 base=$(dirname $0)
6 . "${base}/md5.sh"
7
8 base64=tests/base64${HOSTEXECSUF}
9
10 test="${1#fate-}"
11 target_samples=$2
12 target_exec=$3
13 target_path=$4
14 command=$5
15 cmp=${6:-diff}
16 ref=${7:-"${base}/ref/fate/${test}"}
17 fuzz=${8:-1}
18 threads=${9:-1}
19 thread_type=${10:-frame+slice}
20 cpuflags=${11:-all}
21 cmp_shift=${12:-0}
22 cmp_target=${13:-0}
23 size_tolerance=${14:-0}
24 cmp_unit=${15:-2}
25 gen=${16:-no}
26 hwaccel=${17:-none}
27 report_type=${18:-standard}
28 keep=${19:-0}
29
30 outdir="tests/data/fate"
31 outfile="${outdir}/${test}"
32 errfile="${outdir}/${test}.err"
33 cmpfile="${outdir}/${test}.diff"
34 repfile="${outdir}/${test}.rep"
35
36 target_path(){
37     test ${1} = ${1#/} && p=${target_path}/
38     echo ${p}${1}
39 }
40
41 # $1=value1, $2=value2, $3=threshold
42 # prints 0 if absolute difference between value1 and value2 is <= threshold
43 compare(){
44     awk "BEGIN { v = $1 - $2; printf ((v < 0 ? -v : v) > $3) }"
45 }
46
47 do_tiny_psnr(){
48     psnr=$(tests/tiny_psnr${HOSTEXECSUF} "$1" "$2" $cmp_unit $cmp_shift 0) || return 1
49     val=$(expr "$psnr" : ".*$3: *\([0-9.]*\)")
50     size1=$(expr "$psnr" : '.*bytes: *\([0-9]*\)')
51     size2=$(expr "$psnr" : '.*bytes:[ 0-9]*/ *\([0-9]*\)')
52     val_cmp=$(compare $val $cmp_target $fuzz)
53     size_cmp=$(compare $size1 $size2 $size_tolerance)
54     if [ "$val_cmp" != 0 ] || [ "$size_cmp" != 0 ]; then
55         echo "$psnr"
56         if [ "$val_cmp" != 0 ]; then
57             echo "$3: |$val - $cmp_target| >= $fuzz"
58         fi
59         if [ "$size_cmp" != 0 ]; then
60             echo "size: |$size1 - $size2| >= $size_tolerance"
61         fi
62         return 1
63     fi
64 }
65
66 oneoff(){
67     do_tiny_psnr "$1" "$2" MAXDIFF
68 }
69
70 stddev(){
71     do_tiny_psnr "$1" "$2" stddev
72 }
73
74 oneline(){
75     printf '%s\n' "$1" | diff -u -b - "$2"
76 }
77
78 run(){
79     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
80     $target_exec $target_path/"$@"
81 }
82
83 runecho(){
84     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
85     $target_exec $target_path/"$@" >&3
86 }
87
88 probefmt(){
89     run ffprobe${PROGSUF}${EXECSUF} -show_entries format=format_name -print_format default=nw=1:nk=1 "$@"
90 }
91
92 probeaudiostream(){
93     run ffprobe${PROGSUF}${EXECSUF} -show_entries stream=codec_name,codec_time_base,sample_fmt,channels,channel_layout:side_data "$@"
94 }
95
96 probetags(){
97     run ffprobe${PROGSUF}${EXECSUF} -show_entries format_tags "$@"
98 }
99
100 runlocal(){
101     test "${V:-0}" -gt 0 && echo ${base}/"$@" ${base} >&3
102     ${base}/"$@" ${base}
103 }
104
105 probeframes(){
106     run ffprobe${PROGSUF}${EXECSUF} -show_frames "$@"
107 }
108
109 probechapters(){
110     run ffprobe${PROGSUF}${EXECSUF} -show_chapters "$@"
111 }
112
113 probegaplessinfo(){
114     filename="$1"
115     shift
116     run ffprobe${PROGSUF}${EXECSUF} -bitexact -select_streams a -show_entries format=start_time,duration:stream=index,start_pts,duration_ts "$filename" "$@"
117     pktfile1="${outdir}/${test}.pkts"
118     framefile1="${outdir}/${test}.frames"
119     cleanfiles="$cleanfiles $pktfile1 $framefile1"
120     run ffprobe${PROGSUF}${EXECSUF} -bitexact -select_streams a -of compact -count_packets -show_entries packet=pts,dts,duration,flags:stream=nb_read_packets "$filename" "$@" > "$pktfile1"
121     head -n 8 "$pktfile1"
122     tail -n 9 "$pktfile1"
123     run ffprobe${PROGSUF}${EXECSUF} -bitexact -select_streams a -of compact -count_frames -show_entries frame=pkt_pts,pkt_dts,best_effort_timestamp,pkt_duration,nb_samples:stream=nb_read_frames "$filename" "$@" > "$framefile1"
124     head -n 8 "$framefile1"
125     tail -n 9 "$framefile1"
126 }
127
128 ffmpeg(){
129     dec_opts="-hwaccel $hwaccel -threads $threads -thread_type $thread_type"
130     ffmpeg_args="-nostdin -nostats -noauto_conversion_filters -cpuflags $cpuflags"
131     for arg in $@; do
132         [ x${arg} = x-i ] && ffmpeg_args="${ffmpeg_args} ${dec_opts}"
133         ffmpeg_args="${ffmpeg_args} ${arg}"
134     done
135     run ffmpeg${PROGSUF}${EXECSUF} ${ffmpeg_args}
136 }
137
138 ffprobe_demux(){
139     filename=$1
140     shift
141     print_filename=$(basename "$filename")
142     run ffprobe${PROGSUF}${EXECSUF} -print_filename "${print_filename}" \
143         -of compact -bitexact -show_format -show_streams -show_packets  \
144         -show_data_hash CRC32 "$filename" "$@"
145 }
146
147 framecrc(){
148     ffmpeg "$@" -bitexact -f framecrc -
149 }
150
151 ffmetadata(){
152     ffmpeg "$@" -bitexact -f ffmetadata -
153 }
154
155 framemd5(){
156     ffmpeg "$@" -bitexact -f framemd5 -
157 }
158
159 crc(){
160     ffmpeg "$@" -f crc -
161 }
162
163 md5pipe(){
164     ffmpeg "$@" md5:
165 }
166
167 md5(){
168     encfile="${outdir}/${test}.out"
169     cleanfiles="$cleanfiles $encfile"
170     ffmpeg -y "$@" $(target_path $encfile) || return
171     do_md5sum $encfile | awk '{print $1}'
172 }
173
174 pcm(){
175     ffmpeg -auto_conversion_filters "$@" -vn -f s16le -
176 }
177
178 fmtstdout(){
179     fmt=$1
180     shift 1
181     ffmpeg -bitexact "$@" -f $fmt -
182 }
183
184 enc_dec_pcm(){
185     out_fmt=$1
186     dec_fmt=$2
187     pcm_fmt=$3
188     src_file=$(target_path $4)
189     shift 4
190     encfile="${outdir}/${test}.${out_fmt}"
191     cleanfiles=$encfile
192     encfile=$(target_path ${encfile})
193     ffmpeg -auto_conversion_filters -i $src_file "$@" -f $out_fmt -y ${encfile} || return
194     ffmpeg -auto_conversion_filters -bitexact -i ${encfile} -c:a pcm_${pcm_fmt} -fflags +bitexact -f ${dec_fmt} -
195 }
196
197 FLAGS="-flags +bitexact -sws_flags +accurate_rnd+bitexact -fflags +bitexact"
198 DEC_OPTS="-threads $threads -idct simple $FLAGS"
199 ENC_OPTS="-threads 1        -idct simple -dct fastint"
200
201 enc_dec(){
202     src_fmt=$1
203     srcfile=$2
204     enc_fmt=$3
205     enc_opt=$4
206     dec_fmt=$5
207     dec_opt=$6
208     ffprobe_opts=$9
209     encfile="${outdir}/${test}.${enc_fmt}"
210     decfile="${outdir}/${test}.out.${dec_fmt}"
211     cleanfiles="$cleanfiles $decfile"
212     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
213     tsrcfile=$(target_path $srcfile)
214     tencfile=$(target_path $encfile)
215     tdecfile=$(target_path $decfile)
216     ffmpeg -auto_conversion_filters -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
217         -f $enc_fmt -y $tencfile || return
218     do_md5sum $encfile
219     echo $(wc -c $encfile)
220     ffmpeg -auto_conversion_filters $8 $DEC_OPTS -i $tencfile $ENC_OPTS $dec_opt $FLAGS \
221         -f $dec_fmt -y $tdecfile || return
222     do_md5sum $decfile
223     tests/tiny_psnr${HOSTEXECSUF} $srcfile $decfile $cmp_unit $cmp_shift
224     test -z $ffprobe_opts || \
225         run ffprobe${PROGSUF}${EXECSUF} $ffprobe_opts $tencfile || return
226 }
227
228 transcode(){
229     src_fmt=$1
230     srcfile=$2
231     enc_fmt=$3
232     enc_opt=$4
233     final_decode=$5
234     ffprobe_opts=$7
235     encfile="${outdir}/${test}.${enc_fmt}"
236     test "$6" = -keep || cleanfiles="$cleanfiles $encfile"
237     tsrcfile=$(target_path $srcfile)
238     tencfile=$(target_path $encfile)
239     ffmpeg -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
240         -f $enc_fmt -y $tencfile || return
241     do_md5sum $encfile
242     echo $(wc -c $encfile)
243     ffmpeg $DEC_OPTS -i $tencfile $ENC_OPTS $FLAGS $final_decode \
244         -f framecrc - || return
245     test -z $ffprobe_opts || \
246         run ffprobe${PROGSUF}${EXECSUF} $ffprobe_opts $tencfile || return
247 }
248
249 stream_remux(){
250     src_fmt=$1
251     srcfile=$2
252     enc_fmt=$3
253     stream_maps=$4
254     final_decode=$5
255     ffprobe_opts=$7
256     encfile="${outdir}/${test}.${enc_fmt}"
257     test "$6" = -keep || cleanfiles="$cleanfiles $encfile"
258     tsrcfile=$(target_path $srcfile)
259     tencfile=$(target_path $encfile)
260     ffmpeg -f $src_fmt -i $tsrcfile $stream_maps -codec copy $FLAGS \
261         -f $enc_fmt -y $tencfile || return
262     ffmpeg $DEC_OPTS -i $tencfile $ENC_OPTS $FLAGS $final_decode \
263         -f framecrc - || return
264     test -z $ffprobe_opts || \
265         run ffprobe${PROGSUF}${EXECSUF} $ffprobe_opts $tencfile || return
266 }
267
268 # FIXME: There is a certain duplication between the avconv-related helper
269 # functions above and below that should be refactored.
270 ffmpeg2="$target_exec ${target_path}/ffmpeg${PROGSUF}${EXECSUF}"
271 raw_src="${target_path}/tests/vsynth1/%02d.pgm"
272 pcm_src="${target_path}/tests/data/asynth1.sw"
273 crcfile="tests/data/$test.lavf.crc"
274 target_crcfile="${target_path}/$crcfile"
275
276 [ "${V-0}" -gt 0 ] && echov=echov || echov=:
277
278 echov(){
279     echo "$@" >&3
280 }
281
282 AVCONV_OPTS="-nostdin -nostats -noauto_conversion_filters -y -cpuflags $cpuflags"
283 COMMON_OPTS="-flags +bitexact -idct simple -sws_flags +accurate_rnd+bitexact -fflags +bitexact"
284 DEC_OPTS="$COMMON_OPTS -threads $threads"
285 ENC_OPTS="$COMMON_OPTS -threads 1 -dct fastint"
286
287 run_avconv(){
288     $echov $ffmpeg2 $AVCONV_OPTS $*
289     $ffmpeg2 $AVCONV_OPTS $*
290 }
291
292 do_avconv(){
293     f="$1"
294     shift
295     set -- $* ${target_path}/$f
296     run_avconv $*
297     do_md5sum $f
298     echo $(wc -c $f)
299 }
300
301 do_avconv_crc(){
302     f="$1"
303     shift
304     run_avconv $* -f crc "$target_crcfile"
305     echo "$f $(cat $crcfile)"
306 }
307
308 lavf_audio(){
309     t="${test#lavf-}"
310     outdir="tests/data/lavf"
311     file=${outdir}/lavf.$t
312     do_avconv $file -auto_conversion_filters $DEC_OPTS $1 -ar 44100 -f s16le -i $pcm_src "$ENC_OPTS -metadata title=lavftest" -t 1 -qscale 10 $2
313     do_avconv_crc $file -auto_conversion_filters $DEC_OPTS $3 -i $target_path/$file
314 }
315
316 lavf_container(){
317     t="${test#lavf-}"
318     outdir="tests/data/lavf"
319     file=${outdir}/lavf.$t
320     do_avconv $file -auto_conversion_filters $DEC_OPTS -f image2 -c:v pgmyuv -i $raw_src $DEC_OPTS -ar 44100 -f s16le $1 -i $pcm_src "$ENC_OPTS -metadata title=lavftest" -b:a 64k -t 1 -qscale:v 10 $2
321     test "$3" = "disable_crc" ||
322         do_avconv_crc $file -auto_conversion_filters $DEC_OPTS -i $target_path/$file $3
323 }
324
325 lavf_container_attach() {          lavf_container "" "$1 -attach ${raw_src%/*}/00.pgm -metadata:s:t mimetype=image/x-portable-greymap"; }
326 lavf_container_timecode_nodrop() { lavf_container "" "$1 -timecode 02:56:14:13"; }
327 lavf_container_timecode_drop()   { lavf_container "" "$1 -timecode 02:56:14.13 -r 30000/1001"; }
328
329 lavf_container_timecode()
330 {
331     lavf_container_timecode_nodrop "$@"
332     lavf_container_timecode_drop "$@"
333     lavf_container "" "$1"
334 }
335
336 lavf_container_fate()
337 {
338     t="${test#lavf-fate-}"
339     outdir="tests/data/lavf-fate"
340     file=${outdir}/lavf.$t
341     input="${target_samples}/$1"
342     do_avconv $file -auto_conversion_filters $DEC_OPTS $2 -i "$input" "$ENC_OPTS -metadata title=lavftest" -vcodec copy -acodec copy
343     do_avconv_crc $file -auto_conversion_filters $DEC_OPTS -i $target_path/$file $3
344 }
345
346 lavf_image(){
347     t="${test#lavf-}"
348     outdir="tests/data/images/$t"
349     mkdir -p "$outdir"
350     file=${outdir}/%02d.$t
351     run_avconv $DEC_OPTS -f image2 -c:v pgmyuv -i $raw_src $1 "$ENC_OPTS -metadata title=lavftest" -vf scale -frames 13 -y -qscale 10 $target_path/$file
352     do_md5sum ${outdir}/02.$t
353     do_avconv_crc $file -auto_conversion_filters $DEC_OPTS $2 -i $target_path/$file $2
354     echo $(wc -c ${outdir}/02.$t)
355 }
356
357 lavf_image2pipe(){
358     t="${test#lavf-}"
359     t="${t%pipe}"
360     outdir="tests/data/lavf"
361     file=${outdir}/${t}pipe.$t
362     do_avconv $file -auto_conversion_filters $DEC_OPTS -f image2 -c:v pgmyuv -i $raw_src -f image2pipe "$ENC_OPTS -metadata title=lavftest" -t 1 -qscale 10
363     do_avconv_crc $file -auto_conversion_filters $DEC_OPTS -f image2pipe -i $target_path/$file
364 }
365
366 lavf_video(){
367     t="${test#lavf-}"
368     outdir="tests/data/lavf"
369     file=${outdir}/lavf.$t
370     do_avconv $file -auto_conversion_filters $DEC_OPTS -f image2 -c:v pgmyuv -i $raw_src "$ENC_OPTS -metadata title=lavftest" -t 1 -qscale 10 $1 $2
371     do_avconv_crc $file -auto_conversion_filters $DEC_OPTS -i $target_path/$file $1
372 }
373
374 refcmp_metadata(){
375     refcmp=$1
376     pixfmt=$2
377     fuzz=${3:-0.001}
378     ffmpeg $FLAGS $ENC_OPTS \
379         -lavfi "testsrc2=size=300x200:rate=1:duration=5,format=${pixfmt},split[ref][tmp];[tmp]avgblur=4[enc];[enc][ref]${refcmp},metadata=print:file=-" \
380         -f null /dev/null | awk -v ref=${ref} -v fuzz=${fuzz} -f ${base}/refcmp-metadata.awk -
381 }
382
383 pixfmt_conversion(){
384     conversion="${test#pixfmt-}"
385     outdir="tests/data/pixfmt"
386     raw_dst="$outdir/$conversion.out.yuv"
387     file=${outdir}/${conversion}.yuv
388     run_avconv $DEC_OPTS -r 1 -f image2 -c:v pgmyuv -i $raw_src \
389                $ENC_OPTS -f rawvideo -t 1 -s 352x288 -pix_fmt $conversion $target_path/$raw_dst
390     do_avconv $file $DEC_OPTS -f rawvideo -s 352x288 -pix_fmt $conversion -i $target_path/$raw_dst \
391               $ENC_OPTS -f rawvideo -s 352x288 -pix_fmt yuv444p
392 }
393
394 video_filter(){
395     filters=$1
396     shift
397     label=${test#filter-}
398     raw_src="${target_path}/tests/vsynth1/%02d.pgm"
399     printf '%-20s' $label
400     ffmpeg $DEC_OPTS -f image2 -vcodec pgmyuv -i $raw_src \
401         $FLAGS $ENC_OPTS -vf "$filters" -vcodec rawvideo -frames:v 5 $* -f nut md5:
402 }
403
404 pixfmts(){
405     filter=${test#filter-pixfmts-}
406     filter=${filter%_*}
407     filter_args=$1
408     prefilter_chain=$2
409     nframes=${3:-1}
410
411     showfiltfmts="$target_exec $target_path/libavfilter/tests/filtfmts${EXECSUF}"
412     scale_exclude_fmts=${outfile}_scale_exclude_fmts
413     scale_in_fmts=${outfile}_scale_in_fmts
414     scale_out_fmts=${outfile}_scale_out_fmts
415     in_fmts=${outfile}_in_fmts
416
417     # exclude pixel formats which are not supported as input
418     $showfiltfmts scale | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_in_fmts
419     $showfiltfmts scale | awk -F '[ \r]' '/^OUTPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_out_fmts
420     comm -12 $scale_in_fmts $scale_out_fmts >$scale_exclude_fmts
421
422     $showfiltfmts $filter | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$in_fmts
423     pix_fmts=$(comm -12 $scale_exclude_fmts $in_fmts)
424
425     outertest=$test
426     for pix_fmt in $pix_fmts; do
427         test=$pix_fmt
428         video_filter "${prefilter_chain}scale,format=$pix_fmt,$filter=$filter_args" -pix_fmt $pix_fmt -frames:v $nframes
429     done
430
431     rm $in_fmts $scale_in_fmts $scale_out_fmts $scale_exclude_fmts
432     test=$outertest
433 }
434
435 gapless(){
436     sample=$(target_path $1)
437     extra_args=$2
438
439     decfile1="${outdir}/${test}.out-1"
440     decfile2="${outdir}/${test}.out-2"
441     decfile3="${outdir}/${test}.out-3"
442     cleanfiles="$cleanfiles $decfile1 $decfile2 $decfile3"
443
444     # test packet data
445     ffmpeg -auto_conversion_filters $extra_args -i "$sample" -bitexact -c:a copy -f framecrc -y $(target_path $decfile1)
446     do_md5sum $decfile1
447     # test decoded (and cut) data
448     ffmpeg -auto_conversion_filters $extra_args -i "$sample" -bitexact -f wav md5:
449     # the same as above again, with seeking to the start
450     ffmpeg -auto_conversion_filters $extra_args -ss 0 -seek_timestamp 1 -i "$sample" -bitexact -c:a copy -f framecrc -y $(target_path $decfile2)
451     do_md5sum $decfile2
452     ffmpeg -auto_conversion_filters $extra_args -ss 0 -seek_timestamp 1 -i "$sample" -bitexact -f wav md5:
453     # test packet data, with seeking to a specific position
454     ffmpeg -auto_conversion_filters $extra_args -ss 5 -seek_timestamp 1 -i "$sample" -bitexact -c:a copy -f framecrc -y $(target_path $decfile3)
455     do_md5sum $decfile3
456 }
457
458 gaplessenc(){
459     sample=$(target_path $1)
460     format=$2
461     codec=$3
462
463     file1="${outdir}/${test}.out-1"
464     cleanfiles="$cleanfiles $file1"
465
466     # test data after reencoding
467     ffmpeg -i "$sample" -bitexact -map 0:a -c:a $codec -af aresample -f $format -y "$(target_path "$file1")"
468     probegaplessinfo "$(target_path "$file1")"
469 }
470
471 audio_match(){
472     sample=$(target_path $1)
473     trefile=$2
474     extra_args=$3
475
476     decfile="${outdir}/${test}.wav"
477     cleanfiles="$cleanfiles $decfile"
478
479     ffmpeg -auto_conversion_filters -i "$sample" -bitexact $extra_args -y $(target_path $decfile)
480     tests/audiomatch${HOSTEXECSUF} $decfile $trefile
481 }
482
483 concat(){
484     template=$1
485     sample=$2
486     mode=$3
487     extra_args=$4
488
489     concatfile="${outdir}/${test}.ffconcat"
490     packetfile="${outdir}/${test}.ffprobe"
491     cleanfiles="$concatfile $packetfile"
492
493     awk "{gsub(/%SRCFILE%/, \"$sample\"); print}" $template > $concatfile
494
495     if [ "$mode" = "md5" ]; then
496         run ffprobe${PROGSUF}${EXECSUF} -bitexact -show_streams -show_packets -safe 0 $extra_args $(target_path $concatfile) | tr -d '\r' > $packetfile
497         do_md5sum $packetfile
498     else
499         run ffprobe${PROGSUF}${EXECSUF} -bitexact -show_streams -show_packets -of compact=p=0:nk=1 -safe 0 $extra_args $(target_path $concatfile)
500     fi
501 }
502
503 venc_data(){
504     file=$1
505     stream=$2
506     frames=$3
507     run tools/venc_data_dump${EXECSUF} ${file} ${stream} ${frames} ${threads} ${thread_type}
508 }
509
510 null(){
511     :
512 }
513
514 # Disable globbing: command arguments may contain globbing characters and
515 # must be kept verbatim
516 set -f
517
518 exec 3>&2
519 eval $command >"$outfile" 2>$errfile
520 err=$?
521
522 if [ $err -gt 128 ]; then
523     sig=$(kill -l $err 2>/dev/null)
524     test "${sig}" = "${sig%[!A-Za-z]*}" || unset sig
525 fi
526
527 if test -e "$ref" || test $cmp = "oneline" || test $cmp = "null" || test $cmp = "grep" ; then
528     case $cmp in
529         diff)   diff -u -b "$ref" "$outfile"            >$cmpfile ;;
530         rawdiff)diff -u    "$ref" "$outfile"            >$cmpfile ;;
531         oneoff) oneoff     "$ref" "$outfile"            >$cmpfile ;;
532         stddev) stddev     "$ref" "$outfile"            >$cmpfile ;;
533         oneline)oneline    "$ref" "$outfile"            >$cmpfile ;;
534         grep)   grep       "$ref" "$errfile"            >$cmpfile ;;
535         null)   cat               "$outfile"            >$cmpfile ;;
536     esac
537     cmperr=$?
538     test $err = 0 && err=$cmperr
539     if [ "$report_type" = "ignore" ]; then
540         test $err = 0 || echo "IGNORE\t${test}" && err=0 && unset sig
541     else
542         test $err = 0 || cat $cmpfile
543     fi
544 else
545     echo "reference file '$ref' not found"
546     err=1
547 fi
548
549 if [ $err -eq 0 ] && test $report_type = "standard" ; then
550     unset cmpo erro
551 else
552     cmpo="$($base64 <$cmpfile)"
553     erro="$($base64 <$errfile)"
554 fi
555 echo "${test}:${sig:-$err}:$cmpo:$erro" >$repfile
556
557 if test $err != 0 && test $gen != "no" ; then
558     echo "GEN     $ref"
559     cp -f "$outfile" "$ref"
560     err=$?
561 fi
562
563 if test $err = 0; then
564     if test $keep = 0; then
565         rm -f $outfile $errfile $cmpfile $cleanfiles
566     fi
567 elif test $gen = "no"; then
568     echo "Test $test failed. Look at $errfile for details."
569     test "${V:-0}" -gt 0 && cat $errfile
570 else
571     echo "Updating reference failed, possibly no output file was generated."
572 fi
573 exit $err